#ifndef MCS_IO_H_
#define MCS_IO_H_

#include<fstream>
#include<cstdlib>
#include<ext/algorithm>
#include <sys/time.h>
#include"DATA_Patterns.h"
#include"mcsPatternFinding.h"
#include"mcsClustering.h"
#include"mcsERPAP.h"
#include"mcs_xml_io.h"


//**************************************************************************
//**************************************************************************

    
   typedef __gnu_cxx::hash_map<string,Molecule,StringHash,StringEq>           MoleculeMAP;
   typedef __gnu_cxx::hash_map<string,Molecule,StringHash,StringEq>::iterator MolMapITER;
   
class mcsEnsemble
{
public:
      	
                  	mcsEnsemble(const mcsOptions& newOptions) : ensOptions(newOptions)
                  	{
                  		load_input_data(ensOptions.cmdLineValues);
                  	};
	virtual			~mcsEnsemble() {};
  
   			void	startALL();
    
private:  

   PatternPairMap 						ensemblePatterns;
   mcsClustering::ClusterMapTYPE 		ensembleClusters;
   MoleculeMAP    						ensembleMolecules;
   PatternPairMap						ensembleMaxERPAP;
   
   mcsOptions	  						ensOptions;
   
   int 									sizeERPAP;
  
   void           clearEnsemble();
   void           load_input_data(const vector<string>& mydata);
   void           readFileInput2(string myFile1,Molecule& mol1,Molecule& mol2);
   string         getNext(std::ifstream &myFile, string& what, string& content);
   //void           updateEnsemblePatterns(const PatternPairMap& myPairMap); 
   void           startClustering();
   void           startERPAP();
   void			  extractMatchings();
   void           writeClustersAsPS(const int& myClusterSaveCount,const bool writeXML);                               
 /*  void           writePatternMapAsPS(const Molecule& myMol1,
                                      const Molecule& myMol2,
                                      const PatternPairMap& myMap);*/
   void           clusterToPS(const Molecule& myMol1,
                              const Molecule& myMol2,
                              const string&	  myId,
                              const int&      mySize,
                              const PatternPairMap& myMap);
   void           WriteAllToXML();                                          
   void           printPatternMap();
};

#endif /*MCS_IO_H_*/
